import type {
  domain,
  researchActiveSchema,
  searchActiveTab,
  selectionFilterItems,
} from "~/types/researchTypes";
import { defineStore } from "pinia";

export const useResearchStore = defineStore("researchStore", {
  persist: {
    storage: piniaPluginPersistedstate.localStorage(),
  },
  state: () => ({
    researchActiveSchema: [] as researchActiveSchema[],
    researchSchema: [] as researchActiveSchema[],
    researchDomainActive: {} as domain,
    searchActiveTab: undefined as searchActiveTab | undefined,
    selectionFilterItems: [] as selectionFilterItems,
    // dataForTreeMap: undefined,
    // activeTab: undefined,
    // navigateListActiveTab: undefined,
    // navigateListSchema: undefined,
    // activeNavigateListSchema: undefined,
    // navigateChartActiveTab: undefined,
    // navigateChartSchema: undefined,
    // activeNavigateChartSchema: undefined,
  }),
  getters: {
    researchSchemaGetter(state) {
      return state.researchSchema;
    },
    researchActiveSchemaGetter(state) {
      return state.researchActiveSchema;
    },
    researchDomainActiveGetter(state) {
      return state.researchDomainActive;
    },
    searchActiveTabGetter(state) {
      return state.searchActiveTab;
    },
    selectionFilterItemsGetter(state) {
      return state.selectionFilterItems;
    },

    // dataForTreeMapGetter(state) {
    //   return state.dataForTreeMap;
    // },
    // activeTabGetter(state) {
    //   return state.activeTab;
    // },
    // navigateListActiveTabGetter(state) {
    //   return state.activeTab;
    // },
    // navigateListSchemaGetter(state) {
    //   return state.navigateListSchema;
    // },
    // activeNavigateListSchemaGetter(state) {
    //   return state.activeNavigateListSchema;
    // },
    // activeTabGetter(state) {
    //   return state.activeTab;
    // },
    // navigateChartSchemaGetter(state) {
    //   return state.navigateChartSchema;
    // },
    // activeNavigateChartSchemaGetter(state) {
    //   return state.activeNavigateChartSchema;
    // },
  },
  actions: {
    researchSchemaSetter(researchSchema = undefined) {
      this.researchSchema = researchSchema;
    },

    researchActiveSchemaSetter(researchActiveSchema = undefined) {
      this.researchActiveSchema = researchActiveSchema;
    },
    researchDomainActiveSetter(domain: domain) {
      this.researchDomainActive = domain;
    },
    searchActiveTabSetter(searchActiveTab = undefined) {
      this.searchActiveTab = searchActiveTab;
    },
    selectionFilterItemsSetter(
      selectionFilterItems: selectionFilterItems = []
    ) {
      this.selectionFilterItems = selectionFilterItems;
    },
    // dataForTreeMapSetter(state, dataForTreeMap = undefined) {
    //   state.dataForTreeMap = dataForTreeMap;
    // },
    // activeTabSetter(state, activeTab = undefined) {
    //   state.activeTab = activeTab;
    // },
    // navigateChartActiveTabSetter(state, navigateChartActiveTab = undefined) {
    //   state.navigateChartActiveTab = navigateChartActiveTab;
    // },
    // navigateChartSchemaSetter(state, navigateChartSchema = undefined) {
    //   state.navigateChartSchema = navigateChartSchema;
    // },
    // activeNavigateChartSchemaSetter(
    //   state,
    //   activeNavigateChartSchema = undefined
    // ) {
    //   state.activeNavigateChartSchema = activeNavigateChartSchema;
    // },
  },
});
